
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"

extern void	Error(),ReadSliceImage();

#ifdef	__MSVCRT__
#define FORMAT	"%I64u"
#else
#define FORMAT	"%llu"
#endif

#define PAIRS	unsigned long long

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**Px,**Py;
	int	Nh,Nv,Nd,h,v,d,Nx,Ny,y,x;
	double	Bx,By,Sx,Sy,t;
	Cell	**Cx,**Cy;
	PAIRS	**pairs,largest;

	if (argc!=9) Error("usage : si_pair_hg xDir xBase xStep xPels"
					     " yDir yBase yStep yPels");

	Px=CheckSliceImages(argv[1],"-",&Nh,&Nv,&Nd,NULL);
	Py=CheckSliceImages(argv[5],"-",&h,&v,&d,NULL);
	if (h!=Nh || v!=Nv || d!=Nd) Error("image size not match.");

	Bx=atof(argv[2]);
	By=atof(argv[6]);
	if ((Sx=atof(argv[3]))<1.0 ||
	    (Sy=atof(argv[7]))<1.0) Error("bad pixel value step.");

	if ((Nx=atoi(argv[4]))<1 ||
	    (Ny=atoi(argv[8]))<1) Error("bad number of pixels.");

	if ((Cx=(Cell **)malloc(sizeof(Cell *)*Nv))==NULL ||
	    (*Cx=(Cell *)malloc(sizeof(Cell)*Nv*Nh))==NULL ||
	    (Cy=(Cell **)malloc(sizeof(Cell *)*Nv))==NULL ||
	    (*Cy=(Cell *)malloc(sizeof(Cell)*Nv*Nh))==NULL ||
	    (pairs=(PAIRS **)malloc(sizeof(PAIRS *)*Ny))==NULL ||
	    (*pairs=(PAIRS *)malloc(sizeof(PAIRS)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	for (v=1; v<Nv; v++) {
	    Cx[v]=Cx[v-1]+Nh;
	    Cy[v]=Cy[v-1]+Nh;
	}
	for (y=0; y<Ny; y++) {
	    if (y>0) pairs[y]=pairs[y-1]+Nx;

	    for (x=0; x<Nx; x++) pairs[y][x]=0;
	}
	for (d=0; d<Nd; d++) {
	  ReadSliceImage(Px[d],Nh,Nv,Cx);
	  ReadSliceImage(Py[d],Nh,Nv,Cy);
	  for (v=0; v<Nv; v++)
	  for (h=0; h<Nh; h++)
	    if ((t=(double)Cx[v][h]-Bx)>=0.0 && (x=(int)(t/Sx))>=0 && x<Nx &&
		(t=(double)Cy[v][h]-By)>=0.0 && (y=(int)(t/Sy))>=0 && y<Ny)
	      ++pairs[y][x];
	}
	largest=0;
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) if (pairs[y][x]>largest) largest=pairs[y][x];

	(void)printf("%d\t%d\t" FORMAT "\n",Nx,Ny,largest);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) (void)printf(FORMAT "\n",pairs[y][x]);

	return 0;
}
